<?php

// SuggestionField Module 0.0.1 for the SilverStripe Blog Module
// 08.06.2009
// By nivanka@whynotonline.com
// Save the whole folder on your SilverStripe root directory and run a db/build?flush=1

class SuggesstionField extends TextField{
	
	protected $source;
	protected $URLFlag;
	
	/**
	 * Returns a suggestion field, class="text" and type="text" with the AJAX functionalities to call to the server and 
	 * retrieve the results which are appropriate
	 */
	function __construct($name, $title = null, $value = "", $source = null, $URLFlag = false , $maxLength = null, $form = null){
		
		$this->source = $source;
		$this->URLFlag = $URLFlag;
		
		parent::__construct($name, $title, $value, $maxLength, $form);
		
		Requirements::javascript("SuggestionField/javascript/jquery.js");
		Requirements::javascript("SuggestionField/javascript/suggestionfield.js");
		Requirements::css("SuggestionField/css/suggestionfield.css");
	}
	
	/**
	 * creates the actual field
	 */
	function Field() {
		$extraClass = $this->extraClass();
		
		$fieldSize = $this->maxLength ? min( $this->maxLength, 30 ) : 30;
		
		$field = "";
		
		if($this->maxLength) {
			$field = "<input class=\"text maxlength$extraClass suggestions\" type=\"text\" id=\"" . $this->id() . "\" name=\"{$this->name}\" value=\"" . $this->attrValue() . "\" maxlength=\"$this->maxLength\" size=\"$fieldSize\" info=\"". $this->source . "\"";
		} 
		else {
			$field = "<input class=\"text$extraClass suggestions\" type=\"text\" id=\"" . $this->id() . "\" name=\"{$this->name}\" value=\"" . $this->attrValue() . "\" info=\"". $this->source . "\"";
		}
		if($this->URLFlag)
			$field .= " Link='1' />";
		else	
			$field .= " Link='0' />";
			
		$field .="<div id=\"" . $this->id() . "_suggesstions\" class=\"suggesstionContainer\"></div>";
		
		return $field;
	}
}

?>
